package esercizio1;


import esercizio1.Tessuto.TipoTessuto;

public class GestioneTessuti {

	public static final int MAX_TESSUTI = 100;
	public static final int MAX_FORNITORI = 30;
	
	private Tessuto[] tessuti;
	private int numTessuti;
	 
	public GestioneTessuti(){
		tessuti = new Tessuto[MAX_TESSUTI];
		numTessuti = 0;
	   	}
	
	public GestioneTessuti(Tessuto[] tessuti, int numTessuti){
		this.tessuti = tessuti;
		this.numTessuti = numTessuti;
	   	}
	
	public void inserisciTessuto(Tessuto t){
		if(numTessuti < MAX_TESSUTI)
			tessuti[numTessuti++]=t;
	}
	
	public int fornitorePrezzoPiuBasso(TipoTessuto tipoTessuto){
		int codiceFornitore=-1;
		double costoMin = Double.POSITIVE_INFINITY;
		for(int i=0;i<numTessuti;i++)
				if(tessuti[i].getTipo() == tipoTessuto && tessuti[i].getCostoAlMetro()<costoMin){
					codiceFornitore = tessuti[i].getCodiceFornitore();
					costoMin=tessuti[i].getCostoAlMetro();
				}		
		return codiceFornitore;
	}
	
	// soluzione alternativa al metodo sopra (fornitorePrezzopiuBasso)
	public int fornitorePrezzoPiuBassoAlternativo(TipoTessuto tipoTessuto){ 
		int min=-1;
		int codiceFornitore=-1;
		// cerco il primo fornitore del tipo di tessuto dato.
		// Appena lo trovo quello diventa il fornitore che, per il momento,
		// fornisce il tessuto del tipo dato al prezzo pi basso
		boolean trovatoPrimo=false;
		for(int i=0;i<numTessuti && !trovatoPrimo;i++){
			if(tessuti[i].getTipo() == tipoTessuto){
				trovatoPrimo=true;
				min=i;
			}
		}
		if(trovatoPrimo){ // ne e' stato trovato almeno uno
			// procedo a cercarne altri, a partire dalla posizione successiva a quella
			// del minimo corrente (min+1) e verifico se hanno un costo inferiore
			for(int i=min+1;i<numTessuti;i++){
				if(tessuti[i].getTipo() == tipoTessuto && tessuti[i].getCostoAlMetro()<tessuti[min].getCostoAlMetro())
					min=i;
			}	
			codiceFornitore = tessuti[min].getCodiceFornitore();
		}
		return codiceFornitore;
	}

	
}
